Beef up tests to the extended header functions
[ric-plt/lib/rmr.git] / test / app_test / run_exrts_test.ksh
1 #!/usr/bin/env ksh
2 # vim: ts=4 sw=4 noet :
3 #==================================================================================
4 #    Copyright (c) 2019 Nokia
5 #    Copyright (c) 2018-2019 AT&T Intellectual Property.
6 #
7 #   Licensed under the Apache License, Version 2.0 (the "License");
8 #   you may not use this file except in compliance with the License.
9 #   You may obtain a copy of the License at
10 #
11 #       http://www.apache.org/licenses/LICENSE-2.0
12 #
13 #   Unless required by applicable law or agreed to in writing, software
14 #   distributed under the License is distributed on an "AS IS" BASIS,
15 #   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
16 #   See the License for the specific language governing permissions and
17 #   limitations under the License.
18 #==================================================================================
19 #
20
21 # ---------------------------------------------------------------------------------
22 #       Mnemonic:       run_exrts_test.ksh
23 #       Abstract:       This is a simple script to set up and run the v_send/ex_rts_receive
24 #                               processes for some library validation on top of nng. This test
25 #                               starts these processes to verify that when a receiver has an ack 
26 #                               message larger than the received message it is able to allocate
27 #                               a new payload which can be returned via the RMR return to sender
28 #                               function.
29 #
30 #                               Example command line:
31 #                                       # run with 10 caller threads sending 10,000 meessages each, 
32 #                                       # 5 receivers, and a 10 mu-s delay between each caller send
33 #                                       ksh ./run_lcall_test.ksh -d 10 -n 10000 -r 5 -c 10
34 #
35 #       Date:           28 October 2019
36 #       Author:         E. Scott Daniels
37 # ---------------------------------------------------------------------------------
38
39 ulimit -c unlimited
40
41 # The sender and receivers are run asynch. Their exit statuses are captured in a
42 # file in order for the 'main' to pick them up easily.
43 #
44 function run_sender {
45         ./v_sender ${nmsg:-10} ${delay:-100000} ${mtype_start_stop:-0:1} 
46         echo $? >/tmp/PID$$.src         # must communicate state back via file b/c asynch
47 }
48
49 # $1 is the instance so we can keep logs separate
50 function run_rcvr {
51         typeset port
52
53         port=$(( 4460 + ${1:-0} ))
54         export RMR_RTG_SVC=$(( 9990 + $1 ))
55         ./ex_rts_receiver $copyclone -p $port
56         echo $? >/tmp/PID$$.$1.rrc
57 }
58
59 #       Drop a contrived route table in such that the sender sends each message to n
60 #       receivers.
61 #
62 function set_rt {
63         typeset port=4460
64         typeset groups="localhost:4460"
65         for (( i=1; i < ${1:-3}; i++ ))
66         do
67                 groups="$groups,localhost:$((port+i))"
68         done
69
70         cat <<endKat >ex_rts.rt
71                 newrt | start
72                 mse |0 | 0 | $groups
73                 mse |1 | 10 | $groups
74                 mse |2 | 20 | $groups
75                 rte |3 | $groups
76                 rte |4 | $groups
77                 rte |5 | $groups
78                 rte |6 | $groups
79                 rte |7 | $groups
80                 rte |8 | $groups
81                 rte |9 | $groups
82                 rte |10 | $groups
83                 rte |11 | $groups
84                 newrt | end
85 endKat
86
87         cat ex_rts.rt
88 }
89
90 # ---------------------------------------------------------
91
92 if [[ ! -f local.rt ]]          # we need the real host name in the local.rt; build one from mask if not there
93 then
94         hn=$(hostname)
95         sed "s!%%hostname%%!$hn!" rt.mask >local.rt
96 fi
97
98 export EX_CFLAGS=""
99 export RMR_ASYNC_CONN=0         # ensure we don't lose first msg as drops waiting for conn look like errors
100 nmsg=100                                        # total number of messages to be exchanged (-n value changes)
101 delay=500                                       # microsec sleep between msg 1,000,000 == 1s
102 wait=1
103 rebuild=0
104 verbose=0
105 nrcvrs=1                                        # this is sane, but -r allows it to be set up
106 use_installed=0
107 mtype_start_stop=""
108
109 while [[ $1 == -* ]]
110 do
111         case $1 in
112                 -c)     copyclone="-c $2"; shift;;
113                 -B)     rebuild=1;;
114                 -d)     delay=${2//,/}; shift;;                         # delay in micro seconds allow 1,000 to make it easier on user
115                 -i)     use_installed=1;;
116                 -m)     mtype_start_stop="$2"; shift;;
117                 -M)     mt_call="EX_CFLAGS=-DMTC=1";;                                   # turn on mt-call receiver option
118                 -n)     nmsg=$2; shift;;
119                 -r) nrcvrs=$2; shift;;
120                 -v)     verbose=1;;
121
122                 *)      echo "unrecognised option: $1"
123                         echo "usage: $0 [-B] [-c caller-threads] [-d micor-sec-delay] [-i] [-M] [-m mtype] [-n num-msgs] [-r num-receivers] [-v]"
124                         echo "  -B forces a rebuild which will use .build"
125                         echo "  -i will use installed libraries (/usr/local) and cause -B to be ignored if supplied)"
126                         echo "  -m mtype  will set the stopping (max) message type; sender will loop through 0 through mtype-1"
127                         echo "  -m start:stop  will set the starting and stopping mtypes; start through stop -1"
128                         echo "  -M enables mt-call receive processing to test the RMR asynch receive pthread"
129                         echo ""
130                         echo "The receivers will run until they have not received a message for a few seconds. The"
131                         echo "sender will send the requested number of messages, 10 by default."
132                         exit 1
133                         ;;
134         esac
135
136         shift
137 done
138
139
140 if (( verbose ))
141 then
142         echo "2" >.verbose
143         export RMR_VCTL_FILE=".verbose"
144 fi
145
146 if (( use_installed ))                  # point at installed library
147 then
148         export LD_LIBRARY_PATH=/usr/local/lib
149         export LIBRARY_PATH=$LD_LIBRARY_PATH
150 else
151         if (( rebuild ))
152         then
153                 build_path=../../.build         # if we rebuild we can insist that it is in .build :)
154                 set -e
155                 ksh ./rebuild.ksh
156                 set +e
157         else
158                 build_path=${BUILD_PATH:-"../../.build"}        # we prefer .build at the root level, but allow user option
159
160                 if [[ ! -d $build_path ]]
161                 then
162                         echo "cannot find build in: $build_path"
163                         echo "either create, and then build RMr, or set BUILD_PATH as an evironment var before running this"
164                         exit 1
165                 fi
166         fi
167
168         if [[ -d $build_path/lib64 ]]
169         then
170                 export LD_LIBRARY_PATH=$build_path:$build_path/lib64
171         else
172                 export LD_LIBRARY_PATH=$build_path:$build_path/lib
173         fi
174 fi
175
176 export LIBRARY_PATH=$LD_LIBRARY_PATH
177 export RMR_SEED_RT=./ex_rts.rt
178
179 set_rt $nrcvrs                                                                                                          # set up the rt for n receivers
180
181 if ! make $mt_call -B v_sender ex_rts_receiver >/tmp/PID$$.log 2>&1                     # for sanity, always rebuild test binaries
182 then
183         echo "[FAIL] cannot make binaries"
184         cat /tmp/PID$$.log
185         rm -f /tmp/PID$$*
186         exit 1
187 fi
188
189 echo "<RUN> binaries built"
190
191 for (( i=0; i < nrcvrs; i++  ))
192 do
193         run_rcvr $i &
194 done
195
196 sleep 2                         # let receivers init so we don't shoot at empty targets
197 if (( verbose ))
198 then
199         netstat -an|grep LISTEN
200 fi
201 run_sender &
202
203 wait
204
205
206 for (( i=0; i < nrcvrs; i++ ))          # collect return codes
207 do
208         head -1 /tmp/PID$$.$i.rrc | read x
209         (( rrc += x ))
210 done
211
212 head -1 /tmp/PID$$.src | read src
213
214 if (( !! (src + rrc) ))
215 then
216         echo "[FAIL] sender rc=$src  receiver rc=$rrc"
217 else
218         echo "[PASS] sender rc=$src  receiver rc=$rrc"
219         rm -f ex_rts.rt
220 fi
221
222 rm /tmp/PID$$.*
223 rm -f .verbose
224
225 exit $(( !! (src + rrc) ))
226